"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CoverageBasedSexCheck(ProtocolElement):
    """
    Evaluation ========================================
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import metrics as metrics_1_1_0

        return {
            "inferredSexKaryotype": metrics_1_1_0.KaryotypicSex,
            "reportedKaryotypicSex": metrics_1_1_0.KaryotypicSex,
            "reportedPhenotypicSex": metrics_1_1_0.Sex,
            "sexQuery": metrics_1_1_0.Query,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import metrics as metrics_1_1_0

        return {
            "org.gel.models.metrics.avro.KaryotypicSex": metrics_1_1_0.KaryotypicSex,
            "org.gel.models.metrics.avro.KaryotypicSex": metrics_1_1_0.KaryotypicSex,
            "org.gel.models.metrics.avro.Sex": metrics_1_1_0.Sex,
            "org.gel.models.metrics.avro.Query": metrics_1_1_0.Query,
            "org.gel.models.metrics.avro.CoverageBasedSexCheck": metrics_1_1_0.CoverageBasedSexCheck,
        }

    __slots__ = [
        "comments",
        "inferredSexKaryotype",
        "reportedKaryotypicSex",
        "reportedPhenotypicSex",
        "sampleId",
        "sexQuery",
    ]

    def __init__(
        self,
        comments=None,
        inferredSexKaryotype=None,
        reportedKaryotypicSex=None,
        reportedPhenotypicSex=None,
        sampleId=None,
        sexQuery=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_1_0.CoverageBasedSexCheck model.

        :param comments:
            Comments
        :type comments: None | str
        :param inferredSexKaryotype:
            Inferred coverage-based sex karyotype
        :type inferredSexKaryotype: None | KaryotypicSex
        :param reportedKaryotypicSex:
            Reported karyotypic sex
        :type reportedKaryotypicSex: None | KaryotypicSex
        :param reportedPhenotypicSex:
            Reported phenotypic sex
        :type reportedPhenotypicSex: None | Sex
        :param sampleId:
            Sample Id
        :type sampleId: None | str
        :param sexQuery:
            Whether the sample is a sex query (yes, no, unknown, notTested)
        :type sexQuery: None | Query
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.1.0"
